package database

import (
	"context"
)

type Database[T any] interface {
	String() string
	Close() error

	Ping(ctx context.Context) error
	Query(ctx context.Context, query string, args ...any) (T, error)
}
